/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Types_PROXY_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Types_PROXY_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesProxyBase.hpp>

#include "v1/commonapi/telux/common/CommonDefinesProxy.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif


#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

template <typename ... _AttributeExtensions>
class Cv2xRadioTypesProxy
    : virtual public Cv2xRadioTypes,
      virtual public Cv2xRadioTypesProxyBase,
      public ::v1::commonapi::telux::common::CommonDefinesProxy<_AttributeExtensions...>,
      virtual public _AttributeExtensions... {
public:
    Cv2xRadioTypesProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~Cv2xRadioTypesProxy();

    typedef Cv2xRadioTypes InterfaceType;

    inline static const char* getInterface() {
        return(Cv2xRadioTypes::getInterface());
    }

    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

    virtual std::future<void> getCompletionFuture();




 private:
    std::shared_ptr< Cv2xRadioTypesProxyBase> delegate_;
};

typedef Cv2xRadioTypesProxy<> Cv2xRadioTypesProxyDefault;


//
// Cv2xRadioTypesProxy Implementation
//
template <typename ... _AttributeExtensions>
Cv2xRadioTypesProxy<_AttributeExtensions...>::Cv2xRadioTypesProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        ::v1::commonapi::telux::common::CommonDefinesProxy<_AttributeExtensions...>(delegate),
        _AttributeExtensions(*(std::dynamic_pointer_cast< Cv2xRadioTypesProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast< Cv2xRadioTypesProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
Cv2xRadioTypesProxy<_AttributeExtensions...>::~Cv2xRadioTypesProxy() {
}


template <typename ... _AttributeExtensions>
const CommonAPI::Address &Cv2xRadioTypesProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool Cv2xRadioTypesProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool Cv2xRadioTypesProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& Cv2xRadioTypesProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& Cv2xRadioTypesProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


template <typename ... _AttributeExtensions>
std::future<void> Cv2xRadioTypesProxy<_AttributeExtensions...>::getCompletionFuture() {
    return delegate_->getCompletionFuture();
}

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1



// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Types_PROXY_HPP_
